;compile sjasmplus
 device zxspectrum128
        ORG 6639
begin
sbuf	equ	$7000; buffer for store tile
;part of BASIC
    db $12,$0A,00,$EE,$34,$FD,$DD ; graphics 4
;print usr (6659)
    DB " USR"
    db $96
    db "6659"
    db $95,$FF,0,0;,$0E
start:
 di
 ld      a, 50h
 ld      (3), a          ; 0x0003 - (1 byte) memory paging mode, saving value to port 2 before writing
 out     (2), a          ; U0,U1,VID

;	ld a,%10001000,($8000),a;blue
;	ld a,%00000100,($8040),a;red
;	ld a,%00100000,($8080),a;green
;	jr $
;build LUTs
plut equ $7E00
	ld hl,plut
bl:
	ld a,l
	and %01110111
	add a,a
	ld (hl),a
	inc h
	ld a,l
	and %10001000
	srl a
	srl a
	srl a
	ld (hl),a
	dec h
	inc l
	jr nz,bl

doscroll:
	ei:halt
	ld hl,$803F
	ld ix,cb

	ld d,8
ds1:
	rl (ix+0)
	inc ix
	sbc a,a
cm: and %00010000
	ld e,a
	push hl
	ld b,plut/256

 dup 64
	ld c,(hl)
	ld a,(bc)
	or e
	ld (hl),a
	inc b
	ld a,(bc)
	ld e,a
	dec b
	dec hl
edup
	pop hl
	ld bc,64
	add hl,bc
	dec d
	jp nz,ds1

cc: ld a,0 ; char counter
	inc a
	ld (cc+1),a
	and 7
	jp nz,doscroll
tp: ld hl,scrtxt
	ld a,(hl):inc hl
;0-3 control codes for colors
	cp 4
	jr nc,nocol
	push hl
	ld l,a
	ld h,0
	ld de,cma
	add hl,de
	ld a,(hl)
	ld (cm+1),a
	pop hl
	ld a,32
nocol:
;
	push hl
	ld l,a
	ld h,0
	ld bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld de,cb
	ld bc,8
	ldir
	pop hl
	push hl
	ld de,st_e
	or a
	sbc hl,de
	ld a,h
	or l
	pop hl
	jr nz,no_text_loop
	ld hl,scrtxt
no_text_loop:
	ld (tp+1),hl
	jp doscroll

cb: ds 8 ; character data

scrtxt: db 1,"*simple scroll* "
 db 2
 db "red"
 db 3
 db "blue"
st_e:

cma:
	db %00000000
	db %00010000
	db %00000001
	db %00010001
	
fnt:incbin "Xeno.fnt"
end
    display /d,start
 display /d,end-begin
 savebin "gr4.bin",begin,end-begin
 
 ;erase previous file
	LUA
	os.remove("gr4.cas")
	ENDLUA
 shellexec "tvctape gr4.bin gr4.cas"
